REBOL [
	Title: "Admin service"
	Author: "SOFTINNOV / Nenad Rakocevic"
	Date: 03/10/2004
	Version: 1.0.0
	Purpose: "UniServe's remote management service"
]


install-service [
	name: 'Admin
	port-id: 9800
	verbose: 0
	
	add-head: func [value][head insert value debase/base to-hex length? value 16]
	
	reply: func [value /error][
		write-client add-head mold reduce [either error ['error]['ok] value]
	]
	
	on-load: does [control: get in shared 'control]
	
	on-new-client: does [stop-at: 4]
	
	process: func [data /local arg][
		switch/default data/1 [
			start [
				reply either data/2 = 'all [
					control/start/all none none
				][
					control/start data/2 data/3
				]
			]
			stop [reply control/stop data/2 data/3]
			list [reply control/list none none]
			stats [reply reduce [system/stats system/stats/recycle]]
			refresh []
			load []
		][reply/error "Control: Invalid command!"]
	]
	
	on-received: func [data][
		 either client/user-data = 'head [
			if verbose > 0 [log/info join "new request: " to string! data]
			process load to-string data
			client/user-data: none
			stop-at: 4
		][
			client/user-data: 'head
			stop-at: to integer! data
		]
	]

	stop-at: 4
]